/* GCC */
#define _CRT_SECURE_NO_DEPRECATE
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <iostream>
#include <iterator>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <ctime>
#include <cstring>
#pragma comment(linker, "/STACK:16777216")
using namespace std;
#define pb push_back
#define ppb pop_back
#define pi 3.1415926535897932384626433832795028841971
#define mp make_pair
#define x first
#define y second
#define sqr(a) (a)*(a)
#define D(a,b) sqrt(((a).x-(b).x)*((a).x-(b).x)+((a).y-(b).y)*((a).y-(b).y))
#define pii pair<int,int>
#define pdd pair<double,double>
#define sz(x) int((x).size())
#define INF 1000000000
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;i--)
#define all(c) (c).begin(), (c).end()
#define SORT(c) sort(all(c))
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
#define L(s) (int)((s).end()-(s).begin())
#define C(a) memset((a),0,sizeof(a))
#define val(ch) (int)(ch)-(int)('0')
#define toch(a) (char)((int)(a)+(int)('0'))
#define VI vector <int>
#define ll long long
struct evn
{
	int c1,c2,cd,t;
};
inline bool operator <(const evn &a,const evn &b)
{
	if (a.cd!=b.cd) return a.cd<b.cd; else
	if (a.t!=b.t) return a.t<b.t; else
	if (a.c1!=b.c1) return a.c1<b.c1; else
	return a.c2<b.c2;
}
int a,b,c,d,i,j,n,m,k,p,pr,ans,ansd;
int com1[201],com2[201];
evn ev[81000];
int lp[201],q[201];
VI sm[201];
bool used[201];
bool edge[201][201];
int iter;
bool dfs(int v)
{
	if (used[v]) return 0;
	used[v]=1;
	int i=0;
	while (i<L(sm[v]))
	{
		if (!edge[v][sm[v][i]])
		{
			swap(sm[v][i],sm[v][L(sm[v])-1]);
			sm[v].ppb();
			continue;
		}
		if (q[sm[v][i]]==-1 || dfs(q[sm[v][i]]))
		{
			q[sm[v][i]]=v;
			lp[v]=sm[v][i];
			return 1;
		}
		i++;
	}
	return 0;
}
inline void match()
{
	b=-1;
	while (p!=b)
	{
		b=p; C(used);
		rept(i,n)
		{
			if (lp[i]==-1 && dfs(i)) p++;
		}
	}
}

int main()
{
	freopen("chess.in","r",stdin);
	freopen("chess.out","w",stdout);
	scanf("%d%d%d",&n,&m,&a);
	rept(i,n) scanf("%d",&com1[i]);
	rept(i,m) scanf("%d",&com2[i]);
	k=0;
	C(edge);
	rept(i,n)
	{
		rept(j,m)
		{
			ev[k].c1=i; ev[k].c2=j; ev[k].cd=com2[j]-com1[i]-a; ev[k++].t=0;
			ev[k].c1=i; ev[k].c2=j; ev[k].cd=com2[j]-com1[i]+a; ev[k++].t=1;	
		}
	}
	sort(ev,ev+k);
	p=0;
	memset(lp,-1,sizeof(lp));
	memset(q,-1,sizeof(q));
	pr=-1;
	ans=0; ansd=-INF;
	rept(i,n) sm[i].clear();
	rept(i,k)
	{
		if (ev[i].t==0)
		{
			pr=0;
			sm[ev[i].c1].pb(ev[i].c2);
			edge[ev[i].c1][ev[i].c2]=1;
		} else
		{
			if (pr==0) match();
			if (p>ans)
			{
				ans=p; ansd=i;
			}
			pr=1;
			if (lp[ev[i].c1]==ev[i].c2) 
			{
				p--;
				lp[ev[i].c1]=-1;
				q[ev[i].c2]=-1;
			}
			edge[ev[i].c1][ev[i].c2]=0;
		}
	}
	rept(i,n) sm[i].clear();
	C(edge);
	memset(lp,-1,sizeof(lp)); memset(q,-1,sizeof(q));
	rept(i,ansd)
	{
		if (ev[i].t==0)
		{
			sm[ev[i].c1].pb(ev[i].c2);
			edge[ev[i].c1][ev[i].c2]=1;
		} else
		{
			edge[ev[i].c1][ev[i].c2]=0;
		}
	}
	printf("%d %d\n",ans,ev[ansd-1].cd);
	match();
	rept(i,n)
	{
		if (lp[i]!=-1) printf("%d %d\n",i+1,lp[i]+1);
	}

	FILE * timing = fopen("timing","a+");
	fprintf(timing, "chess %lf\n", 1.0*clock()/CLOCKS_PER_SEC);
	fclose(timing);

	//cerr<<1.0*clock()/CLOCKS_PER_SEC<<endl;
}
