/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;

vector<bool> used(20);
bool matrix[20][20];
int Pl[20];
int n;
pair<int,vector<int> > Perebor(int cur_n)
{
    int ans = 2000000;
    vector<int> way;
    if(cur_n == n)
    {
        ans = 0;
        for(int i = 0;i < n;i++)
            for(int j = 0;j < n;j++)
                if(matrix[i][j])
                    ans+= abs(Pl[i] - Pl[j]);
        return {ans / 2,{}};
    }
    for(int i = 0;i < n;i++)
    {
        if(used[i])
            continue;
        used[i] = true;
        Pl[i] = cur_n;
        pair<int,vector<int> > hV = Perebor(cur_n + 1);
        if(ans > hV.first)
        {
            way.clear();
            ans = hV.first;
            way.push_back(i);
            for(auto w:hV.second)
                way.push_back(w);
        }
        used[i] = false;
    }
    return {ans,way};
}
int main()
{
    ifstream fin("servers.in");
    int m , a , b;
    fin >> n >> m;
    for(int i = 0;i < n;i++)
        for(int j = 0;j < n;j++)
            matrix[i][j] = false;
    for(int i = 0;i < m;i++)
    {
        fin >> a >> b;
        matrix[a - 1][b - 1] = true;
        matrix[b - 1][a - 1] = true;
    }
    ofstream fout("servers.out");
    pair<int,vector<int> > hV = Perebor(0);
    fout << hV.first << endl;
    for(auto w:hV.second)
        fout << w + 1 << ' ';
    fout << endl;
    return 0;
}
