/* GCC */
#include <cstdio>
#include <vector>
#include <algorithm>
#include <ctime>
using namespace std;

int n;
vector<vector<int> > A;
vector<int> X, Ans;

int Getd(){
    int ans = 0;
    for(int i = 0; i < n; i++) for(int j = 0; j < A[i].size(); j++) ans += abs(X[A[i][j]] - X[i]);
    ans /= 2;
    return ans;
}

int main(){
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
    int m;
    scanf("%d%d", &n, &m);
    X.clear();
    for(int i = 0; i < n; i++) X.push_back(i);
    A.resize(n); Ans.resize(n);
    int Adis = 0;
    int x, y;
    for(int i = 0; i < m; i++){
        scanf("%d%d", &x, &y);
        A[x-1].push_back(y-1);
        A[y-1].push_back(x-1);
    }
    //printf("%d %d\n\n", x,y);
    /*for(int i = 0; i < n; i++){ // 
        for(int j = 0; j < A[i].size(); j++) printf("%d ", A[i][j]);
        printf("\n");
    }printf("\n");
    */
    random_shuffle(X.begin(), X.end());
    Ans = X;
    Adis = Getd();

    srand(time(0));
    for(int ii = 0; ii < 60; ii++){
        random_shuffle(X.begin(), X.end());
        //printf("rr\n");for(int i = 0; i < n; i++) printf("%d ", X[i]); printf("\n\n"); // 
        int Dis = Getd();
        //printf("dis - %d\n\n", Dis); // 
        int Dis1 = Dis, DisM = Dis;
        int i1, j1;

        while(true){
            DisM = Dis;
            for(int i = 0; i < n; i++) for(int j = 0; j < n; j++) if(i != j){
                Dis1 = Dis;
                for(int k = 0; k < A[i].size(); k++) if(A[i][k] != j)
                    Dis1 += (abs(X[A[i][k]]-X[j]) - abs(X[A[i][k]]-X[i]));

                for(int k = 0; k < A[j].size(); k++) if(A[j][k] != i)
                    Dis1 += (abs(X[A[j][k]]-X[i]) - abs(X[A[j][k]]-X[j]));

                //printf("--  %d %d %d\n", Dis1, i, j);
                if(Dis1 < DisM){
                    //printf("  %d %d %d\n", Dis1, i, j); //
                    DisM = Dis1;
                    i1 = i; j1 = j;
                }
            }
            if(DisM == Dis) break;
            Dis = DisM;
            swap(X[i1], X[j1]);
            //printf("\n");for(int i = 0; i < n; i++) printf("%d ", X[i]); printf("\n\n"); //
        }
        if(Adis > Dis){
            Adis = Dis;
            Ans = X;
        }

    }

    printf("%d\n", Adis);
    for(int i = 0; i < n; i++) X[Ans[i]] = i+1;
    for(int i = 0; i < n-1; i++) printf("%d ", X[i]);printf("%d\n", X[n-1]);

    fclose(stdin);
    fclose(stdout);
    return 0;
}
