/* GCC */
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

struct edge
{
    edge(int _1 = 0, int _2 = 0)
        : v1(_1), v2(_2)
    {}
    int v1;
    int v2;
};

int n, m, ans_a[20], a[20], na[20], cur[20], idx[20], ans(1000000);
edge edg[400];

int cost(int* arr)
{
    for(int i = 0; i < n; ++i)
        idx[arr[i]] = i;
    int c(0);
    for(int i = 0; i < m; ++i)
        c += abs(idx[edg[i].v1] - idx[edg[i].v2]);
    return c;
}

int main(void)
{
	ifstream in("servers.in");
	in >> n >> m;
    for(int i = 0; i < m; ++i)
    {
        in >> edg[i].v1 >> edg[i].v2;
        --edg[i].v1, --edg[i].v2;
    }
    in.close();
    for(int i = 0; i < n; ++i)
        a[i] = i;
    vector<edge> ps;
    for(int i = 1; i < n; ++i)
        for(int j = 0; j < i; ++j)
            ps.push_back(edge(i, j));
    for(int _ = 0; _ < 400; ++_)
    {
        random_shuffle(a, a+n);
        random_shuffle(ps.begin(), ps.end());
        int c, nc, cc;
        while(true)
        {
            nc = c = cost(a);
            for(int i = 0; i < ps.size(); ++i)
            {
                copy(a, a + n, cur);
                swap(cur[ps[i].v1], cur[ps[i].v2]);
                if((cc = cost(cur)) < nc)
                {
                    nc = cc;
                    copy(cur, cur + n, na);
                }
            }
            if(nc == c)
                break;
            copy(na, na + n, a);
        }
        c = cost(a);
        if(c < ans)
        {
            ans = c;
            copy(a, a + n, ans_a);
        }
    }
	ofstream out("servers.out");
	out << ans << '\n';
	for(int i = 0; i < n; ++i)
        out << ans_a[i] + 1 << (i == n - 1 ? '\n' : ' ');
	return 0;
}
